Include multi.inc
Include model.inc

;==============================================================================
;
;   CAS function 10h -- Get Current Event Status
;
;   Format:
;               int CASGetCurrentEventStatus (CECS *buffer)
;   Input:
;               pointer to current event structure
;   Output:
;               Returns 0 if successful or negative error code,
;               fills current event structure.
;==============================================================================

                .CODE
CASGetCurrentEventStatus     PROC    arg1:PTR WORD

                push    ds              ; save registers
                push    dx

                mov     ax,MUX          ; load multiplex number
                mov     ah,al           ; move into ah
                mov     al,10h          ; CAS function 10
        IF      @DataSize               ; large and medium models
                lds     dx,arg1         ; pointer to data block
        ELSE
                mov     dx,arg1         ; small model
        ENDIF
                int     2Fh

                cmp     ax,0            ; call successful?
                jne     FINISH          ; unsuccessful, don't change ax
                mov     ax,bx           ; load event handle
FINISH:
                pop     dx              ; restore registers
                pop     ds
                ret
CASGetCurrentEventStatus     endp

                END


