Include multi.inc
Include model.inc

;==============================================================================
;
;   CAS function 12h -- Get Hardware Status
;
;   Format:
;               int CASGetHardwareStatus (HWSTAT *buffer)
;   Input:
;               pointer to hardware status structure
;   Output:
;               Returns 0 if successful or negative error code
;               fills hardware status buffer
;==============================================================================

                .CODE
CASGetHardwareStatus    PROC    arg1:PTR WORD

                push    dx              ; save registers
                push    ds

                mov     ax,MUX          ; load multiplex number
                mov     ah,al           ; move into ah
                mov     al,12h          ; CAS function 12
        IF      @DataSize               ; large and medium models
                lds     dx,arg1         ; pointer to SFTR
        ELSE
                mov     dx,arg1         ; pointer to SFTR
        ENDIF
                int     2Fh
                cmp     ax,0            ; call successful?
                je      FINISH          ; don't modify ax
                mov     ax,1            ; failure code
FINISH:
                pop     ds              ; restore registers
                pop     dx
                ret
CASGetHardwareStatus    endp

                END


