Include multi.inc
Include model.inc

;==============================================================================
;
;   CAS function 13h -- Run Diagnostics
;   
;   Format:
;               int CASRunDiagnostics (BYTE mode); 
;   Input:
;               byte indicating start or status mode
;   Output:
;               start mode:   returns 0 if successful or negative error code.
;               status mode:  returns 40h if diagnostics in progress,
;                             positive number if completed successfully,
;                             negative error code if diagnostics failed.
;==============================================================================

                .CODE
CASRunDiagnostics       PROC    arg1:BYTE  

                push    dx              ; save registers
                
                mov     ax,MUX          ; load multiplex number
                mov     ah,al           ; move into ah
                mov     al,13h          ; CAS function 13
                mov     dl,arg1         ; load mode
                int     2Fh

                pop     dx              ; restore registers
                ret
CASRunDiagnostics       endp
     
                END
                

