Include multi.inc
Include model.inc

;==============================================================================
;
;   CAS function 06h -- Find Next Entry in Queue
;   
;   Format:
;               int CASFindNext (BYTE queue)
;   Input:
;               queue to search
;   Output:
;               Returns event handle or negative error code
;==============================================================================

                .CODE
CASFindNext    PROC    arg1:BYTE 

                push    bx              ; save registers
                push    dx              
                
                mov     ax,MUX          ; load multiplex number
                mov     ah,al           ; move into ah
                mov     al,06h          ; CAS function 6
                mov     dl,arg1         ; direction to search
                int     2Fh

                cmp     ax,0            ; ax = 0?
                jne     FINISH          ; find first failed, return err. code
                mov     ax,bx           ; move event handle to ax
FINISH:         
                pop     dx              ; restore registers
                pop     bx                 
                ret
CASFindNext    endp
     
                END
                

