Include multi.inc
Include model.inc

;==============================================================================
;
;   CAS function Ah -- Get Event Date
;
;   Format:
;               int CASGetEventDate (int handle, BYTE queue, CAS_DATE *date)
;   Input:
;               handle of event, queue for event, pointer to date structure
;   Output:
;               Returns 0 if successful or negative error code, fills
;               date structure.
;==============================================================================

                .CODE
CASGetEventDate         PROC    arg1:WORD, arg2:BYTE, arg3:PTR WORD

                mov     ax,MUX          ; load multiplex number
                mov     ah,al           ; move into ah
                mov     al,0Ah          ; CAS function A
                mov     bx,arg1         ; event handle
                mov     dl,arg2         ; queue
                int     2Fh

                cmp     ax,0            ; ax = 0?
                jne     FINISH          ; get event date failed, return ax
        IF      @DataSize               ; large and medium models
                les     di,arg3         ; pointer to date structure
                mov     es:[di],cx      ; load year
                mov     es:[di+2],dh    ; load month
                mov     es:[di+3],dl    ; load day
        ELSE                            ; small model
                mov     di,arg3         ; pointer to date structure
                mov     [di],cx         ; load year
                mov     [di+2],dh       ; load month
                mov     [di+3],dl       ; load day
        ENDIF
FINISH:
                ret
CASGetEventDate          endp

                END


