Include multi.inc
Include model.inc

;==============================================================================
;
;   CAS function Ch -- Get Event Time
;
;   Format:
;               int CASGetEventTime (int handle, BYTE queue, CAS_TIME *time)
;   Input:
;               handle of event, queue for event, pointer to time structure
;   Output:
;               Returns 0 if successful or negative error code, fills
;               time structure.
;==============================================================================

                .CODE
CASGetEventTime         PROC    arg1:WORD, arg2:BYTE, arg3:PTR WORD

                mov     ax,MUX          ; load multiplex number
                mov     ah,al           ; move into ah
                mov     al,0Ch          ; CAS function C
                mov     bx,arg1         ; event handle
                mov     dl,arg2         ; queue
                int     2Fh

                cmp     ax,0            ; ax = 0?
                jne     FINISH          ; get event date failed, return ax
        IF      @DataSize               ; large and medium models
                les     di,arg3         ; pointer to date structure
                mov     es:[di],ch      ; load hour
                mov     es:[di+1],cl    ; load minutes
                mov     es:[di+2],dh    ; load seconds
        ELSE                            ; small model
                mov     di,arg3         ; pointer to date structure
                mov     [di],ch         ; load hour
                mov     [di+1],cl       ; load minutes
                mov     [di+2],dh       ; load seconds
        ENDIF
FINISH:
                ret
CASGetEventTime         endp

                END


