/* PBERROR.H  Header file for CAS Toolkit Phonebook Error Codes.

   This file must be included in the source files of any application that uses
   the CAS Toolkit Phonebook library.
==============================================================================*/
/*
    ERROR MESSAGE LIST for Phonebook functions.  This list is indexed
    by the global variable Pberrno.
*/
char *PBerrlist[] = {

  /* Phonebook errors */
  "",                                                                      /* 0 NULL               */
  "Error using fseek",                                                     /* 1 FSEEKERROR         */
  "Insufficient memory",                                                   /* 2 OUTOFMEM        */
  "Error opening file",                                                    /* 3 CANTOPEN       */
  "Error writing to file",                                                 /* 4 CANTWRITE      */
  "Error reading file",                                                    /* 5 CANTREAD       */
  "Error closing file",                                                    /* 6 CANTCLOSE      */
  "Structure freed pointed to another structure",                          /* 7 ORPHANWARN      */
  "An ASCIIZ string is longer than allowed",                               /* 8 TOOLONGSTRING      */
  "A file by the given path and name already exists",                      /* 9 FILEALREADYEXISTS  */
  "No file by the given name exists",                                      /* 10 FILEDOESNTEXIST   */
  "Not enough diskspace is available for requested operation",             /* 11 OUTOFDISKSPACE    */
  "The phonebook header contains inconsistent information",                /* 12 INCONSISTENTPBH   */
  "The offset at the given record id is NULL",                             /* 13 NOENTRYPRESENT    */
  "No entry was found to match the given name",                            /* 14 NOENTRYFOUND      */
  "No more entries match the given name specification",                    /* 15 NOMOREMATCH       */
  "Cannot add an entry because the phonebook is full",                     /* 16 PHONEBOOKFULL     */
  "Cannot add an entry because entry is invalid",                          /* 17 INVALIDENTRY      */
  "Cannot add an entry because an existing entry has same name",           /* 18 DUPLICATEENTRY    */
  "Error using filelength(): file handle may be invalid",                  /* 19 FILELENGTHERROR   */
  "A proposed change to an entry is invalid",                              /* 20 INVALIDCHANGE     */
  "",                                                                      /* 21 GROUPNOTEMPTY (not used)*/
  "The phonebook's unused bytes exceeded limit: use PbGarbageCollect",     /* 22 TOOMANYFREEBYTES  */
  "A group cannot be a member",                                            /* 23 GROUPCANTBEMEMBER */
  "A person cannot have a member",                                         /* 24 PERSONCANTHAVEMEMBER */
  "The entry to add to the group is already a member of that group",       /* 25 ENTRYALREADYMEMBER*/
  "The entry to remove from the group is not a member of that group",      /* 26 GROUPDOESNTHAVEMEMBER */
  "The entry doesn't have the group in it's membership list",              /* 27 MEMBERDOESNTHAVEGROUP */
  "One or more of the parameters to the function was invalid",             /* 28 INVALIDPARAMETER  */
  "Cannot add a person entry with memberships: use PbAddToGroup",          /* 29 PERSONNOTEMPTY    */
  "A null value was encountered where a valid pointer was expected",       /* 30 NULLPOINTER       */
  "Invalid Pberrno"                                                        /* 31 LASTMESSAGE       */
  };
